#include <stdio.h>
#include "tbx_timer.h"

tbx_timer *Timer = NULL;

void strtmr()
{
   if (Timer == NULL)
      Timer = new_tbx_timer();
   getrusage(RUSAGE_SELF, &(Timer -> usage_start));
}

void stptmr()
{
   getrusage(RUSAGE_SELF, &(Timer -> usage_stop));
}

void ptrtmr(char *FILENM)
{
   char *Subroutine_name = "ptrtmr():";
   FILE *Timing_file;
   struct rusage *usage_start = &(Timer -> usage_start);
   struct rusage *usage_stop = &(Timer -> usage_stop);
   char  Filename[80];
   int   i;

   i = 0;
   while (FILENM[i] != '.')
   {
      Filename[i] = FILENM[i];
      i++;
   }
   Filename[i] = '\0';
   strcat(Filename, ".dat");

   compute_time(Timer);

   if ((Timing_file = fopen(Filename, "a")) != NULL)
   {
      fprintf(Timing_file, "usage_start.user_time: %ld sec %ld usec\n",
              usage_start -> ru_utime.tv_sec, usage_start -> ru_utime.tv_usec);
      fprintf(Timing_file, "usage_stop.user_time: %ld sec %ld usec\n",
              usage_stop -> ru_utime.tv_sec, usage_stop -> ru_utime.tv_usec);
      fprintf(Timing_file, "usage_start.sys_time: %ld sec %ld usec\n",
              usage_start -> ru_stime.tv_sec, usage_start -> ru_stime.tv_usec);
      fprintf(Timing_file, "usage_stop.sys_time: %ld sec %ld usec\n",
              usage_stop -> ru_stime.tv_sec, usage_stop -> ru_stime.tv_usec);

      fprintf(Timing_file, "%s %ld sec and %ld usec\n", Subroutine_name,
              Timer -> total_sec, Timer -> total_usec);
      fclose(Timing_file);
   }
   else
   {
      printf("%s Cannot open timing file: %s\n", Subroutine_name, Filename);
      exit(1);
   }
   tbx_timer_reset(Timer);
}
